UNIT mTListe;

interface

uses
  bankkonto2;


type

    TInhalt = TBankkonto;

type
   TElement = CLASS
     // weitere Attribute
     private
        Inhalt : TInhalt;
        Naechstes : TElement;
     // weitere Methoden
     public
        procedure SetzeInhalt(pInhalt: TInhalt);
        procedure SetzeNaechstes(E : TElement);
        function GibInhalt : TInhalt;
        function GibNaechstes : TElement;
   end;


   TListe = CLASS
     // weitere Attribute
     private
        ToWurzel : TElement;
        ToCursor : TElement;
        Anzahl : Integer;
     // weitere Methoden
     public
        procedure Init;
        procedure links_anfuegen(Element : TElement);
        procedure loeschen(Inhalt : TInhalt);
        procedure nach_vorne;
        procedure rechts_anfuegen(Element : TElement);
        procedure SetzeAnzahl(pAnzahl: Integer);
        function vor:boolean;
        function GibAnzahl : Integer;
        function leer : Boolean;
        function GibInhalt : TInhalt;
   end;

   TWarteschlange = class(TListe)
   public
      procedure remove;
      function front : TInhalt;
      end;

implementation

//+---------------------------------------------------------------------
//|         TElement: Methodendefinition
//+---------------------------------------------------------------------

//-------- SetzeInhalt (public) ----------------------------------------
procedure TElement.SetzeInhalt(pInhalt: TInhalt);
   begin
      Inhalt := pInhalt
   end;

//-------- SetzeNaechstes (public) ----------------------------------------
procedure TElement.SetzeNaechstes(E : TElement);
begin
   Naechstes:=E;
end;

//-------- GibInhalt (public) ------------------------------------------
function TElement.GibInhalt : TInhalt;
begin
      result  := Inhalt
end;

//-------- GibNaechstes (public) ------------------------------------------
function TElement.GibNaechstes : TElement;
begin
      result  := Naechstes;
end;


//+---------------------------------------------------------------------
//|         TListe: Methodendefinition
//+---------------------------------------------------------------------

//-------- Init (public) -----------------------------------------------
procedure TListe.Init;
Begin
   Anzahl:=0;
End;

//-------- links_anfuegen (public) -------------------------------------
procedure TListe.links_anfuegen(Element : TElement);
Begin
   if Anzahl=0 then begin
      ToWurzel:=TElement.create;
      ToWurzel.SetzeNaechstes(NIL);
      ToWurzel:=Element;
      end
   else begin
      Element.SetzeNaechstes(ToWurzel);
      ToWurzel:=Element;
      end;
   SetzeAnzahl(Anzahl+1);
End;

//-------- loeschen (public) -------------------------------------------
procedure TListe.loeschen(Inhalt:TInhalt);
VAR i : Integer; gefunden : Boolean;
    Aktuell : TElement;
begin
    nach_vorne;
    gefunden:=false;
    for i:=1 to GibAnzahl do begin
//-------- lschen des erstmaligen Vorkommens ---------
      if (Inhalt = GibInhalt) and (not gefunden) then begin
//-------- lschen des letztmaligen Vorkommens ---------
//      if Inhalt = GibInhalt then begin
        gefunden:=true;
        Aktuell:=ToCursor;
        end;
      vor;
      end;
    if gefunden then begin
       if Aktuell=ToWurzel then ToWurzel:=ToWurzel.GibNaechstes
       else begin
         nach_vorne;
         while ToCursor.GibNaechstes<>Aktuell do vor;
         ToCursor.SetzeNaechstes(Aktuell.Naechstes);
         Aktuell.free;
         ToCursor:=ToWurzel;
         end;
         Anzahl:=Anzahl-1;
       end;
end;

//-------- nach_vorne (public) -----------------------------------------
procedure TListe.nach_vorne;
Begin
    if not leer then ToCursor:=ToWurzel;
End;

//-------- rechts_anfuegen (public) ------------------------------------
procedure TListe.rechts_anfuegen(Element : TElement);
VAR i : Integer;
begin
   if Anzahl=0 then begin
      ToWurzel:=TElement.create;
      ToWurzel.SetzeNaechstes(NIL);
      ToWurzel:=Element;
      end
   else begin
      nach_vorne;
      for i:=1 to GibAnzahl-1 do vor;
      ToCursor.SetzeNaechstes(Element);
      Element.SetzeNaechstes(NIL);
      end;
   SetzeAnzahl(Anzahl+1);
end;

//-------- SetzeAnzahl (public) ----------------------------------------
procedure TListe.SetzeAnzahl(pAnzahl: Integer);
   begin
      Anzahl := pAnzahl
   end;

//-------- vor (public) ------------------------------------------------
function TListe.vor:Boolean;
Begin
  result:=false;
  if not leer then
     if ToCursor.Naechstes <> NIL then begin
        ToCursor:=ToCursor.GibNaechstes;
        result:=true;
        end;
End;

//-------- GibAnzahl (public) ------------------------------------------
function TListe.GibAnzahl : Integer;
   begin
      result  := Anzahl
   end;

//-------- leer (public) -----------------------------------------------
function TListe.leer : Boolean;
Begin
   leer:=Anzahl = 0;
End;

//-------- GibInhalt (public) -----------------------------------------------
function TListe.GibInhalt : TInhalt;
begin
   if not leer then GibInhalt:=ToCursor.Inhalt;
end;

//+---------------------------------------------------------------------
//|         TWarteschlange: Methodendefinition
//+---------------------------------------------------------------------

//-------- remove (public) -----------------------------------------------
procedure TWarteschlange.remove;
VAR i:integer;
begin
    if not leer then
       if GibAnzahl=1 then begin
          ToWurzel.Free;
          Init;
          end
       else begin
          nach_vorne;
          for i:=1 to GibAnzahl-1 do vor;
          ToCursor.Free;
          SetzeAnzahl(GibAnzahl-1);
          nach_vorne;
          for i:=1 to GibAnzahl-1 do vor;
          ToCursor.SetzeNaechstes(NIL);
          end;
end;

//-------- front (public) -----------------------------------------------
function TWarteschlange.front : TInhalt;
VAR i : Integer;
begin
  if not leer then begin
    nach_vorne;
    for i:=1 to GibAnzahl-1 do vor;
    front := ToCursor.GibInhalt;
    end;
end;

end.
